//Добавлено меню создания Снеговиков + Установка координатов.
//Исправлены некоторые баги.
//Добавлена функция поворота объекта.

#include < amxmodx >
#include < amxmisc >
#include < dhudmessage >
#include < engine >

#define IN_USE            (1<<5)
#define SM_LVL ADMIN_RCON
#pragma tabsize 0

new const gMdl[ ] = "models/snowman.mdl";

new gPrefix[] = "!g[Снеговики]!y"

new sm_class[] = "SnowMan"
new g_szConfigFile[ 128 ]; 
new Ent, gName[33], gMsg[255], s_angels[64], g_num[64]

public plugin_init( )
{
	register_plugin( "SnowMan", "1.2", "OverGame" )
	
	register_clcmd( "man_spawn",  "snow_menu" )
	register_touch( sm_class, "player", "fwd_touch" )
}

public plugin_cfg( )
{
	new szMapName[ 32 ];
	get_mapname( szMapName, 31 );
	strtolower( szMapName );
	
	formatex( g_szConfigFile, 127, "addons/amxmodx/data/snowman" );
	
	if( !dir_exists( g_szConfigFile ) ) {
		mkdir( g_szConfigFile );
		
		format( g_szConfigFile, 127, "%s/%s.txt", g_szConfigFile, szMapName );
		
		return;
	}
	
	format( g_szConfigFile, 127, "%s/%s.txt", g_szConfigFile, szMapName );
	
	if( !file_exists( g_szConfigFile ) )
		return;
	
	new iFile = fopen( g_szConfigFile, "rt" );
	
	if( !iFile )
		return;
	
	new Float:vOrigin[ 3 ], angels[ 3 ], x[ 16 ], y[ 16 ], z[ 16 ], s[ 16 ], szData[ sizeof( x ) + sizeof( y ) + sizeof( z ) + sizeof( s ) + 3 ];
	
	while( !feof( iFile ) ) {
		fgets( iFile, szData, charsmax( szData ) );
		trim( szData );
		
		if( !szData[ 0 ] )
			continue;
		
		parse( szData, x, 15, y, 15, z, 15, s, 15 );
		
		vOrigin[ 0 ] = str_to_float( x );
		vOrigin[ 1 ] = str_to_float( y );
		vOrigin[ 2 ] = str_to_float( z );
		angels[ 1 ] = str_to_float( s );
		
		CreateFrost( vOrigin, angels );
	}
	
	fclose( iFile );
}

public plugin_precache()
{
	precache_model( gMdl );
}

public client_putinserver(id)
{
	s_angels[id] = 0.0
	g_num[id] = 0
}

public fwd_touch(gid, id)
{
    if ( !(get_user_flags(id) & SM_LVL) ) return PLUGIN_HANDLED;
	
    set_dhudmessage(255, 255, 255, -1.0, 0.84, 0, 1.0, 1.0, 0.1, 0.1)
	format(gMsg, charsmax(gMsg), "Нажмите букву E, что бы удалить снеговика!");
	show_dhudmessage(id, gMsg)
	
    if(entity_get_int(id, EV_INT_button) & IN_USE) 
    { 
	
        new Float:vOrigin[ 3 ], szClassName[ 10 ], Ent = -1, iDeleted;
        entity_get_vector( gid, EV_VEC_origin, vOrigin );
	
        while( ( Ent = find_ent_in_sphere( Ent, vOrigin, 100.0 ) ) > 0 ) 
		{
            entity_get_string( Ent, EV_SZ_classname, szClassName, 9 );
		
            if( equal( szClassName, sm_class ) ) 
		    {
			    remove_entity( gid );
			
			    iDeleted++;
            }
        }
	
        if( iDeleted > 0 )
		SaveFrost( );
		
		get_user_name(id, gName, 32)
		
        ChatColor(0, "%s Администратор!t %s !y удалил!t %i!y снеговиков с карты!", gPrefix, gName, iDeleted)
    }
	
	return PLUGIN_HANDLED;
}

public snow_menu(id)
{
        static s_MenuItem[255]
        formatex(s_MenuItem, charsmax(s_MenuItem), "\d[Снеговики]\r Меню установки")
		
        new menu = menu_create(s_MenuItem, "snow_menu_hand" )
		
        menu_additem(menu, "\yСоздать","1")
		
		if ( g_num[id] == 0 )
		{
			menu_additem(menu, "\r0 \yградусов","2")
		} else
		if ( g_num[id] == 1 )
		{
			menu_additem(menu, "\r60 \yградусов","2")
		} else
		if ( g_num[id] == 2 )
		{
			menu_additem(menu, "\r-60 \yградусов","2")
		} else
		if ( g_num[id] == 3 )
		{
			menu_additem(menu, "\r120 \yградусов","2")
		} else
		if ( g_num[id] == 4 )
		{
			menu_additem(menu, "\r-120 \yградусов","2")
		} else
		if ( g_num[id] == 5 )
		{
			menu_additem(menu, "\r160 \yградусов","2")
		} else
		if ( g_num[id] == 6 )
		{
			menu_additem(menu, "\r-160 \yградусов","2")
		} else
		if ( g_num[id] == 7 )
		{
			menu_additem(menu, "\r180 \yградусов","2")
		} else
		if ( g_num[id] == 8 )
		{
			menu_additem(menu, "\r-180 \yградусов","2")
		}
		
        menu_setprop(menu, MPROP_EXITNAME, "Выход")
 
        menu_display(id,menu,0)
        return PLUGIN_HANDLED
}

public snow_menu_hand(id, menu, item)
{
        if(item == MENU_EXIT)
        {
                menu_destroy(menu)
                return PLUGIN_HANDLED
        }
 
        new data[6], iName[64], access, callback
        menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
 
        new key = str_to_num(data)
 
        switch(key)
        {
        case 1:{
                        add_object(id)
                }
        case 2:{
                        
						if ( g_num[id] == 0 )
						{
							s_angels[id] = 60.0
							g_num[id]++
						} else
						if ( g_num[id] == 1 )
						{
							s_angels[id] = -60.0
							g_num[id]++
						} else
						if ( g_num[id] == 2 )
						{
							s_angels[id] = 120.0
							g_num[id]++
						} else
						if ( g_num[id] == 3 )
						{
							s_angels[id] = -120.0
							g_num[id]++
						} else
						if ( g_num[id] == 4 )
						{
							s_angels[id] = 160.0
							g_num[id]++
						} else
						if ( g_num[id] == 5 )
						{
							s_angels[id] = -160.0
							g_num[id]++
						} else
						if ( g_num[id] == 6 )
						{
							s_angels[id] = 180.0
							g_num[id]++
						} else
						if ( g_num[id] == 7 )
						{
							s_angels[id] = -180.0
							g_num[id]++
						} else
						if ( g_num[id] == 8 )
						{
							s_angels[id] = 0.0
							g_num[id] = 0
						}
                }
        }
		
		snow_menu(id)
		
        return PLUGIN_HANDLED
}

public add_object(id)
{
    if ( !(get_user_flags(id) & SM_LVL) ) return PLUGIN_HANDLED;
	

    Ent = create_entity("info_target")
     
    if(is_valid_ent(Ent))
	{
        entity_set_model(Ent, gMdl)
		entity_set_string(Ent, EV_SZ_classname, sm_class)
        entity_set_size( Ent, Float:{ -1.0, -1.0, -1.0 }, Float:{ 1.0, 1.0, 36.0 } );
        new Float:vOrigin[3]
        entity_get_vector(id, EV_VEC_origin, vOrigin)    
        vOrigin[0] += 50.0
        entity_set_origin(Ent, vOrigin)        
        entity_set_int(Ent,EV_INT_solid,SOLID_BBOX)
		
        new Float:angles[3]
        angles[1] = s_angels[id]
        entity_set_vector(Ent, EV_VEC_angles, angles)

        drop_to_floor(Ent)
		
        get_user_name(id, gName, 32)
		
        ChatColor(0, "%s Администратор!t %s!y создал снеговика!", gPrefix, gName)
		
		SaveFrost( );
    }
	
	return Ent;
}

CreateFrost( const Float:vOrigin[ 3 ], const Float:angels[ 3 ] ) {
	Ent = create_entity( "info_target" );
	
    if(is_valid_ent(Ent))
	{
        entity_set_model(Ent, gMdl)
		entity_set_string(Ent, EV_SZ_classname, sm_class)
        entity_set_size( Ent, Float:{ -1.0, -1.0, -1.0 }, Float:{ 1.0, 1.0, 36.0 } );
        entity_set_origin(Ent, vOrigin)
		entity_set_vector(Ent, EV_VEC_angles, angels)
        entity_set_int(Ent,EV_INT_solid,SOLID_BBOX)

        drop_to_floor(Ent)
    }
	
	return Ent;
}

SaveFrost( )
{
	if( file_exists( g_szConfigFile ) )
		delete_file( g_szConfigFile );
	
	new iFile = fopen( g_szConfigFile, "wt" );
	
	if( !iFile )
		return;
	
	new Float:vOrigin[ 3 ], angels[ 3 ], Ent;
	
	while( ( Ent = find_ent_by_class( Ent, sm_class ) ) > 0 ) {
		entity_get_vector( Ent, EV_VEC_origin, vOrigin );
		entity_get_vector(Ent, EV_VEC_angles, angels)
		
		fprintf( iFile, "%f %f %f %f^n", vOrigin[ 0 ], vOrigin[ 1 ], vOrigin[ 2 ], angels[ 1 ] );
	}
	
	fclose( iFile );

}

stock ChatColor(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[188]
	vformat(msg, 187, input, 3)
	
	replace_all(msg, 187, "!g", "^4")
	replace_all(msg, 187, "!y", "^1")
	replace_all(msg, 187, "!t", "^3")
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}